% -*- mode: slang; mode: fold; -*- ------------------------------------------
%
%  SigRoT            by Tomasz 'tsca' Sienicki <tsca@cryogen.com>
%                  <http://www.geocities.com/tsca.geo/slang.html>
%
%{{{ Description: -----------------------------------------------------------
%          SigRoT inserts a random (unless wished otherwise) signature at the
% end of the current bufer.  The signatures are stored in one file, separated
% by lines beginning with 'sig/x' (without quotes) where x is the number of a
% signature.  Sigs are numbered, because sometimes I wish to use a particular
% one. An example signature file is included in the sigrot package.  Upon the 
% first execution the macro inserts a random sig  in a non-interactive manner
% (pressing additional keys  everytime you followup/reply would simply be too
% annoying). The next time you run the macro, however, you are asked to enter
% the number of the sig you want to insert. Hitting ENTER, entering too big a 
% value or some rubbish results in inserting a random sig  and displaying its
% number in the minibuffer (this way you'll quickly learn the numbers of sigs 
% you wish to remember).    You can call the macro as many times as you want:
% signatures will be replaced, not added. 
% It is possible to call the macro with an argument: desired signature number
% (eg. 'sig(5);' will insert the signature number five).
% USAGE: --------------------------------------------------------------------
% Put this file in /usr/local/jed/lib/ and add the following to .jedrc:
%    () = evalfile ("sigrot.sl");
% and to .slrnrc:
%    set post_editor_command "jed '%s' -tmp -f sigrot"
% or, if you use jed in mail_mode
%    set post_editor_command "jed '%s' -tmp -f '{mail_mode;sigrot;}'"
% Put a similar line in case of .muttrc/.pinerc/.whateverrc
% To do: --------------------------------------------------------------------
% automatically checking how many entries there are in the signature file.
% History: ------------------------------------------------------------------
% v1.0 Tue, 23 Nov 1999, 20:41:37
% v1.2 Wed,  2 Aug 2000, 23:11:43 [(n) thingy added]
%}}} ------------------------------------------------------------------------

define sig (n)
{
 variable
 no_of_sigs = 66,            % how many signatures are there in the file
 filesig = "/home/x/.sigs",  % full path + filename of your sig file

%{{{ Don't need to change anything below %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

 los, tlos=0, pocz, juz=0;
 eob(); if (re_bsearch("^-- $")) {push_mark; eob(); del_region; juz=1;}
 !if(n) {() = random (-1, 0); los = random (0,no_of_sigs); los++;} else los=n;
 if(juz){tlos=integer(read_mini("Enter no (0 for random): ","0",Null_String));
 !if(orelse{not tlos}{tlos>no_of_sigs}){los=tlos;}}

 pocz = sprintf("sig/%d",los,1);
 eob(); !if (re_fsearch("^$")) {insert ("\n");}
 insert ("-- \n"); insert_file_region(filesig,pocz,"sig/");
 eob(); if (re_bsearch("^sig/[0-9]")) {push_mark;eol;del_region;del;up(2);}
 message (sprintf ("Signature no %d inserted.  [SigRoT by tsca]",los,1));
}
%}}} -- END --
